<template>
  <b-row class="build">
    <b-col md="8">
      <Loading :loading="this.$apollo.queries.build.loading" />

      <div v-if="!this.$apollo.queries.build.loading">
        <router-link
          class="caption"
          :to="`/build/${build.prev.id}`"
          v-if="build.prev"
        >
          <b-icon-arrow-left-short /> {{ build.prev.tag }}
        </router-link>
        <b-icon-dot v-if="build.prev" />
        <router-link class="caption" :to="`/system/${build.system.id}`">
          {{ build.system.name }}
        </router-link>
        <b-icon-dot v-if="build.next" />
        <router-link
          class="caption"
          :to="`/build/${build.next.id}`"
          v-if="build.next"
        >
          {{ build.next.tag }} <b-icon-arrow-right-short />
        </router-link>

        <h1>{{ build.tag }} <BuildSummary :summary="build.summary" /></h1>

        <BuildControls :build="build" />
        <ul style="margin-top: 1em">
          <li>
            Released on {{ new Date(Number(build.date)).toLocaleString() }}
          </li>
          <li>Channel: {{ build.channel }}</li>
        </ul>

        <LineChart
          v-if="
            !this.$apollo.queries.build.loading && (build.prev || build.next)
          "
          :chartData="build.chart"
        />

        <h2>Tests</h2>
        <b-table
          ref="testsTable"
          :items="build.tests"
          :fields="[
            { key: 'name', sortable: true },
            { key: 'weight', sortable: true },
            { key: 'status', sortable: true }
          ]"
          sort-by="status"
          :sort-desc="true"
          selectable
          select-mode="single"
          class="mt-3"
          outlined
          striped
          @row-selected="testSelected"
        >
          <template v-slot:cell(name)="data">
            <router-link :to="`/test/${data.item.test.id}`">
              {{ data.item.test.name }}
            </router-link>
          </template>
          <template v-slot:cell(weight)="data">
            {{ data.item.test.weight }}
          </template>
          <template v-slot:cell(status)="data">
            <Status :status="data.item.status" />
          </template>

          <template v-slot:row-details="row">
            <b-card :v-if="row._showDetails">
              <div
                v-for="combination in build.combinations"
                v-bind:key="JSON.stringify(combination.combination)"
              >
                <TensorSlice
                  :label="
                    combination.combination
                      .map(m => `${m.variable}: ${m.value}`)
                      .join(', ')
                  "
                  :build="build.id"
                  :test="row.item.test.id"
                  :combination="combination.combination"
                />
              </div>
            </b-card>
          </template>
        </b-table>

        <div v-if="build.system.properties.length > 0">
          <h2>Combinations</h2>
          <b-table
            ref="combinationsTable"
            :items="
              build.combinations.map(i => {
                let r = {};
                i.combination.forEach(j => (r[j.variable] = j.value));
                r.status = i.status;
                r.combination = i.combination;
                return r;
              })
            "
            :fields="[
              ...build.system.properties.map(p => ({
                key: p.name,
                sortable: true
              })),
              { key: 'status', sortable: true }
            ]"
            sort-by="status"
            :sort-desc="true"
            selectable
            select-mode="single"
            class="mt-3"
            outlined
            striped
            @row-selected="combinationSelected"
          >
            <template v-slot:cell(name)="data">
              <router-link :to="`/test/${data.item.test.id}`">
                {{ data.item.test.name }}
              </router-link>
            </template>
            <template v-slot:cell(weight)="data">
              {{ data.item.test.weight }}
            </template>
            <template v-slot:cell(status)="data">
              <Status :status="data.item.status" />
            </template>

            <template v-slot:row-details="row">
              <b-card :v-if="row._showDetails">
                <div v-for="test in build.tests" v-bind:key="test.id">
                  <TensorSlice
                    :label="test.test.name"
                    :build="build.id"
                    :test="test.test.id"
                    :combination="row.item.combination"
                  />
                </div>
              </b-card>
            </template>
          </b-table>
        </div>

        <h2>Runs</h2>
        <p>
          There have been {{ build.runs.length || "no" }} runs reported for this
          build
        </p>
        <b-table
          v-show="build.runs && build.runs.length"
          :items="build.runs"
          :fields="[
            { key: 'date', sortable: true },
            { key: 'user', sortable: true },
            { key: 'test', sortable: true },
            { key: 'result', sortable: true }
          ]"
          sort-by="date"
          :sort-desc="true"
          selectable
          select-mode="single"
          class="mt-3"
          outlined
          striped
          @row-selected="runSelected"
        >
          <template v-slot:cell(test)="data">
            <router-link :to="`/test/${data.value.id}`">
              {{ data.value.name }}
            </router-link>
          </template>

          <template v-slot:cell(user)="data">
            <router-link v-if="data.value" :to="`/user/${data.value.id}`">
              {{ data.value.name }}
            </router-link>
            <i v-else>Anonymous</i>
          </template>

          <template v-slot:cell(date)="data">
            <router-link :to="`/run/${data.item.id}`">
              {{ new Date(Number(data.value)).toLocaleString() }}
            </router-link>
          </template>

          <template v-slot:cell(result)="data">
            <RunResult :result="data.value" />
          </template>
        </b-table>
      </div>
    </b-col>

    <SystemSidebar md="4" :system="build.system" />
  </b-row>
</template>

<script>
import Loading from "@/components/Loading.vue";
import TensorSlice from "@/components/TensorSlice.vue";
import BuildControls from "@/components/BuildControls.vue";
import SystemSidebar from "@/components/SystemSidebar.vue";
import Status from "@/components/Status.vue";
import RunResult from "@/components/RunResult.vue";
import BuildSummary from "@/components/BuildSummary.vue";
import LineChart from "@/components/charts/Line.vue";
import gql from "graphql-tag";

export default {
  name: "Build",
  data() {
    return {
      build: {
        id: this.$route.params.id,
        system: { tests: [], builds: [], properties: [] },
        channel: "default",
        runs: [],
        tests: [],
        combinations: []
      }
    };
  },
  components: {
    LineChart,
    Loading,
    TensorSlice,
    BuildControls,
    SystemSidebar,
    Status,
    RunResult,
    BuildSummary
  },
  apollo: {
    build: {
      query: gql`
        query build($buildId: ID!) {
          build(id: $buildId) {
            id
            tag
            summary
            date
            channel
            chart {
              labels
              datasets {
                label
                backgroundColor
                data
              }
            }
            prev {
              id
              tag
            }
            next {
              id
              tag
            }
            tests {
              test {
                id
                name
                weight
              }
              status {
                pass
                wonky
                fail
                inconclusive
              }
            }
            combinations {
              combination {
                variable
                value
              }
              status {
                pass
                wonky
                fail
                inconclusive
              }
            }
            runs {
              id
              date
              result
              user {
                id
                name
              }
              test {
                id
                name
              }
            }
            system {
              id
              name
              description
              image
              tests {
                id
                name
                description
              }
              builds {
                id
                tag
              }
              combinationFilter
              properties {
                id
                name
                description
                values
              }
            }
          }
        }
      `,
      variables() {
        return {
          buildId: this.$route.params.id
        };
      },
      error() {
        this.$router.push({ path: `/dashboard/` });
      }
    }
  },
  methods: {
    testSelected(items) {
      if (items && items[0]) {
        if (!(this?.build?.combinations?.length > 1)) {
          this.$router.push({ path: `/test/${items[0].test.id}` });
        } else {
          items[0]._showDetails = !items[0]._showDetails;
          this.$refs.testsTable.clearSelected();
        }
      }
    },
    combinationSelected(items) {
      if (items && items[0] && this?.build?.tests?.length > 1) {
        items[0]._showDetails = !items[0]._showDetails;
      }
      this.$refs.combinationsTable.clearSelected();
    },
    runSelected(items) {
      this.$router.push({ path: `/run/${items[0].id}` }).catch(() => {});
    }
  }
};
</script>
